
import java.applet.Applet;
import java.awt.*;
import java.awt.image.MemoryImageSource;
import java.util.Random;

public class Fire extends Applet implements Runnable {
    private int[] pixels;
    private int[] fire;
    private int[] colorLookup;
    private int width4;
    private int height4;
    private int width;
    private int height;
    private Image image;
    private MemoryImageSource imagesrc;
    private Random rand;
    private boolean painted;

    public int getWidth() {
	return getSize().width;
    }

    public int getHieght() {
	return getSize().height;
    }

    public void init() {
        super.init();
        height = getHeight();
        width = getWidth();
	width4 = width / 4;
	height4 = height / 4;
        pixels = new int [width * height];
        fire = new int[width4 * height4 + 1];
        colorLookup = new int[256];
        for (int i = 0; i < 64; i++) {
            colorLookup[i] = 0xFF000000 + i * 0x040000;
            colorLookup[i+64] = 0xFF000000 + i * 0x400 + 0xFF0000;
            colorLookup[i+128] = 0xFF000000 + i * 0x4 + 0xFFFF00;
            colorLookup[i+192] = 0xFF000000 + 0xFFFFFF;
        }
        int index = 0;
        for (int y = 0; y < height; y++) {
            for (int x = 0; x < width; x++) {
                pixels[index++] = 0xFF000000;
            }
        }
        imagesrc = new MemoryImageSource(width, height, pixels, 0, width);
        imagesrc.setAnimated(true);
        imagesrc.setFullBufferUpdates(true);
        image = createImage(imagesrc);
        rand = new Random();
        new Thread(this).start();
    }

    public void start() {
        super.start();
    }

    public void stop() {
        super.stop();
    }

    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
        g.drawImage(image, 0, 0, this);
	painted = true;
    }

    public void run() {
        while (true) {
            updateFire();
	    while (!painted)
		;
        /*    try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                e.printStackTrace();  //To change body of catch statement use Options | File Templates.
            }*/
        }
    }

    private void updateFire() {
        for (int i = 0; i < width/16; i++) {
            fire[width4*(height4-1) + rand.nextInt(width4+1)] = 255;
        }
        for (int i = 0; i < width/16; i++) {
            fire[width4*(height4-1) + rand.nextInt(width4+1)] = 0;
        }
        int index = 0;
        for (int y = 0; y < height4 - 1; y++) {
            for (int x = 0; x < width4; x++) {
                fire[index] =
                        (
                        fire[index + 1] +
                        fire[index + width4] +
                        fire[index] +
                        fire[index + width4+1]
                        ) / 4;
                if (fire[index] > 0) {
                    fire[index]--;
                }
                index++;
            }
        }
	int pindex = 0;
	index = 0;
	for (int y = 0; y < height4 - 1; y++) {
	    for (int x = 0; x < width4; x++) {
		int pindex2 = pindex;
		int color = colorLookup[fire[index++]];
		for (int y1 = 0; y1 < 4; y1++) {
		    for (int x1 = 0; x1 < 4; x1++) {
                        pixels[pindex2++] = color;
		    }
		    pindex2 += width - 4;
		}
		pindex+=4;
	    }
	    pindex += width * 3;
        } 

        painted = false;
        imagesrc.newPixels();

    }
}

